#code to generate excel file for simulation tables for continuous mediators and a dichotomous outcome
#
library ("plyr")

#main text table 1 & 2 and supplementary text S4----
for.excel=matrix(NA, nr=15, nc=50)
#sim1
exposure.values=c(0.2,0.35,0.49,0.6)
for (i in 1:4){
  co.sim.1.param=test.sim.setting(1000, c(0.05,0.05), 0, 1000, exposure.values[i],0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1)
  hist(co.sim.1.param[,1]/1000,xlab=c("proportion of individuals with the outcome"), main=c("Distribution of the outcome in 1000 simulations")) #want this to be normally distributed
  mean.sim=mean(co.sim.1.param[,1]/1000)
  mean.sim.M=mean(co.sim.1.param[,5]/1000)
  mean.sim.G=mean(co.sim.1.param[,6]/1000)
  for.excel[i,]=c(mean.sim, mean.sim.M, mean.sim.G,sim.mediation.calc( c(0.05,0.05), 0, 1000, exposure.values[i],0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1))
}
for.excel[5,]=c(mean.sim, mean.sim.M, mean.sim.G,sim.mediation.calc( c(0.05,0.05),  c(0,1), 1000, 0.49,0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1))

#sim2
for (i in 1:4){
  co.sim.1.param=test.sim.setting(1000,  c(0.05,0.05), 0, 1000, exposure.values[i],-0.2, -0.3, -0.4, -0.4, 0, 0.2, 0.2, 0.2, 0.5)
  hist(co.sim.1.param[,1]/1000,xlab=c("proportion of individuals with the outcome"), main=c("Distribution of the outcome in 1000 simulations")) #want this to be normally distributed
  mean.sim=mean(co.sim.1.param[,1]/1000)
  mean.sim.M=mean(co.sim.1.param[,5]/1000)
  mean.sim.G=mean(co.sim.1.param[,6]/1000)
  for.excel[i+5,]=c(mean.sim, mean.sim.M, mean.sim.G,sim.mediation.calc(c(0.05,0.05), 0, 1000, exposure.values[i],-0.2, -0.3, -0.4, -0.4, 0, 0.2, 0.2, 0.2, 0.5,c(), 1000, 1))
}
for.excel[10,]=c(mean.sim, mean.sim.M, mean.sim.G,sim.mediation.calc( c(0.05,0.05),  c(0,1), 1000, 0.49,-0.2, -0.3, -0.4, -0.4, 0, 0.2, 0.2, 0.2, 0.5,c(), 1000, 1))

#sim3
for (i in 1:4){
  co.sim.1.param=test.sim.setting(1000, c(0.1,0.1), 0, 1000, exposure.values[i],0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1)
  hist(co.sim.1.param[,1]/1000,xlab=c("proportion of individuals with the outcome"), main=c("Distribution of the outcome in 1000 simulations")) #want this to be normally distributed
  mean.sim=mean(co.sim.1.param[,1]/1000)
  mean.sim.M=mean(co.sim.1.param[,5]/1000)
  mean.sim.G=mean(co.sim.1.param[,6]/1000)
  for.excel[i+10,]=c(mean.sim, mean.sim.M, mean.sim.G,sim.mediation.calc(c(0.1,0.1), 0, 1000, exposure.values[i],0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1))
}
data.sim=sim.mediation.calc( c(0.1,0.1),  c(0,1), 1000, 0.49,0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1)
for.excel[15,]=c(mean.sim, mean.sim.M, mean.sim.G,data.sim)

for.excel=as.data.frame(for.excel)
names(for.excel)=c("mean outcome", "mean mediator 1", "mean mediator 2", names(data.sim))

rownames(for.excel)=c("sim1D exp 0.2","sim1D exp 0.35","sim1D exp 0.49","sim1D exp 0.6","sim1C", "sim2D exp 0.2","sim2D exp 0.35","sim2D exp 0.49","sim2D exp 0.6", "sim2C", "sim3D exp 0.2","sim3D exp 0.35","sim3D exp 0.49","sim3D exp 0.6","sim3C")
write.csv(for.excel, file = "cont_table1_Feb21.csv", row.names = T)

final.RDmain.table1=for.excel[,c(1:3, 33:35, 10,36:38, 11, 39:41,12)]
write.csv(final.RDmain.table1,file="main_table1RD_cont_Feb21.csv" , row.names=T)
final.RRmain.table1=for.excel[,c(1:3, 42:44, 13,45:47, 14, 48:50,15)]
write.csv(final.RRmain.table1,file="main_table2RR_cont_Feb21.csv" , row.names=T)
supp.table2=for.excel[,c(16:19,20:28)]
write.csv(supp.table2,file="supp_table2_cont_Feb21.csv" , row.names=T)

#generating data for supplement appendix 5 and 6----
#comparison with bootstrap, generate data for each scenario then use the same data to generate 95% CI
#simulation 1
fig2.sim1=matrix(NA, nr=8,nc=32)
exposure.values=c(0.2,0.35,0.49,0.6)
for (i in 1:4){
  sim.x=as.data.frame(sim.mediation.data(c(0.05,0.05), 0, 1000, exposure.values[i], 1,0.1,0.1,0.4,-0.4,0.1,0.2,0.2,0,0.1 ))
  delta.paths=mediation.analysis(1,sim.x,c())
  boot.paths=boot.mediation.analysis(1, sim.x, c(),n.boot=1000)
  fig2.sim1[((i*2)-1),]=delta.paths
  fig2.sim1[(i*2),]=boot.paths
}

fig2.sim1=as.data.frame(fig2.sim1)
names(fig2.sim1)=names(delta.paths)

#for simulation 2
fig2.sim2=matrix(NA, nr=8,nc=32)
exposure.values=c(0.2,0.35,0.49,0.6)
for (i in 1:4){
  sim.x=as.data.frame(sim.mediation.data(c(0.05,0.05), 0, 1000, exposure.values[i], 1,-0.2,-0.3,-0.4,-0.4,0, 0.2,0.2,0.2,0.5))
  delta.paths=mediation.analysis(1,sim.x,c())
  boot.paths=boot.mediation.analysis(1, sim.x, c(),n.boot=1000)
  fig2.sim2[((i*2)-1),]=delta.paths
  fig2.sim2[(i*2),]=boot.paths
}

fig2.sim2=as.data.frame(fig2.sim2)
names(fig2.sim2)=names(delta.paths)

write.csv(rbind(fig2.sim1, fig2.sim2), "figure2data_Feb21.csv")
#calculate true values for each PSE for sim 1 and sim 2 that can be later used for plotting----

calc.true.value=function(sigm, sigg, beta.0, beta.s, beta.m, beta.g, alpha.0, alpha.s, alpha.m,delta.0, delta.s){
  s.star=sqrt((sigg^2)*(beta.g^2) + 1 + ((beta.m+beta.g*alpha.m)^2)*(sigm^2))
  sa=1
  sb=0
  sc=0
  first=pnorm((beta.0+beta.s*sa+beta.g*(alpha.0+alpha.s*sb)+(beta.m+beta.g*alpha.m)*(delta.0+delta.s*sc))/s.star)
  sa=0
  second=pnorm((beta.0+beta.s*sa+beta.g*(alpha.0+alpha.s*sb)+(beta.m+beta.g*alpha.m)*(delta.0+delta.s*sc))/s.star)
  p1=first-second #risk difference number of 95% CI covers
  r1=first/second #risk ratio number of 95% CI covers true
  sa=1
  sb=1
  sc=0
  first=pnorm((beta.0+beta.s*sa+beta.g*(alpha.0+alpha.s*sb)+(beta.m+beta.g*alpha.m)*(delta.0+delta.s*sc))/s.star)
  sb=0
  second=pnorm((beta.0+beta.s*sa+beta.g*(alpha.0+alpha.s*sb)+(beta.m+beta.g*alpha.m)*(delta.0+delta.s*sc))/s.star)
  p2=first-second
  r2=first/second
  sa=1
  sb=1
  sc=1
  first=pnorm((beta.0+beta.s*sa+beta.g*(alpha.0+alpha.s*sb)+(beta.m+beta.g*alpha.m)*(delta.0+delta.s*sc))/s.star)
  sc=0
  second=pnorm((beta.0+beta.s*sa+beta.g*(alpha.0+alpha.s*sb)+(beta.m+beta.g*alpha.m)*(delta.0+delta.s*sc))/s.star)
  p3=first-second
  r3=first/second
  return(c(p1,p2,p3,r1,r2,r3))
}
true.values.sim1=calc.true.value(0.05,0.05,0.1,0.1,0.4,-0.4,0.1,0.2,0.2,0,0.1)
true.values.sim2=calc.true.value(0.05,0.05,-0.2,-0.3,-0.4,-0.4,0, 0.2,0.2,0.2,0.5)


#supplement appendix 5: plot RD----
dev.off()
png(filename="continuous_figure2RD.png")
par(mfrow=c(2,3), oma=c(2,3,0,0), mar=c(3,2,2,2))
#for path 1:
x.lab=c("exp 0.2","exp 0.35", "exp 0.49", "exp 0.6")
plot(fig2.sim1[,1],  xaxt="n", ylim=c(-0.2, 0.4), ylab="", main="Path 1", xlab="")
points(c(2,4,6,8),fig2.sim1[c(2,4,6,8),1], pch=19)
arrows(c(1,3,5,7), fig2.sim1[c(1,3,5,7),2], c(1,3,5,7), fig2.sim1[c(1,3,5,7),3], length=0.05, angle=90, code=3, lty=1)
arrows(c(2,4,6,8), fig2.sim1[c(2,4,6,8),2], c(2,4,6,8), fig2.sim1[c(2,4,6,8),3], length=0.05, angle=90, code=3, lty=6)
axis(1, at=c(1,3,5,7)+0.5, labels=x.lab, tick=FALSE)
abline(h=true.values.sim1[1])
#for path 2:
x.lab=c("exp 0.2","exp 0.35", "exp 0.49", "exp 0.6")
plot(fig2.sim1[,5],  xaxt="n", ylim=c(-0.2, 0.4), ylab="", main="Path 2",xlab="")
points(c(2,4,6,8),fig2.sim1[c(2,4,6,8),5], pch=19)
arrows(c(1,3,5,7), fig2.sim1[c(1,3,5,7),6], c(1,3,5,7), fig2.sim1[c(1,3,5,7),7], length=0.05, angle=90, code=3, lty=1)
arrows(c(2,4,6,8), fig2.sim1[c(2,4,6,8),6], c(2,4,6,8), fig2.sim1[c(2,4,6,8),7], length=0.05, angle=90, code=3, lty=6)
axis(1, at=c(1,3,5,7)+0.5, labels=x.lab, tick=FALSE)
abline(h=true.values.sim1[2])
#for path 3:
x.lab=c("exp 0.2","exp 0.35", "exp 0.49", "exp 0.6")
plot(fig2.sim1[,9],  xaxt="n", ylim=c(-0.2, 0.4), ylab="", main="Path 3",xlab="")
points(c(2,4,6,8),fig2.sim1[c(2,4,6,8),9], pch=19)
arrows(c(1,3,5,7), fig2.sim1[c(1,3,5,7),10], c(1,3,5,7), fig2.sim1[c(1,3,5,7),11], length=0.05, angle=90, code=3, lty=1)
arrows(c(2,4,6,8), fig2.sim1[c(2,4,6,8),10], c(2,4,6,8), fig2.sim1[c(2,4,6,8),11], length=0.05, angle=90, code=3, lty=6)
axis(1, at=c(1,3,5,7)+0.5, labels=x.lab, tick=FALSE)
abline(h=true.values.sim1[3])

#for path 1:
x.lab=c("exp 0.2","exp 0.35", "exp 0.49", "exp 0.6")
plot(fig2.sim2[,1],  xaxt="n", ylim=c(-0.5, 0.2), ylab="", main="Path 1",xlab="")
points(c(2,4,6,8),fig2.sim2[c(2,4,6,8),1], pch=19)
arrows(c(1,3,5,7), fig2.sim2[c(1,3,5,7),2], c(1,3,5,7), fig2.sim2[c(1,3,5,7),3], length=0.05, angle=90, code=3, lty=1)
arrows(c(2,4,6,8), fig2.sim2[c(2,4,6,8),2], c(2,4,6,8), fig2.sim2[c(2,4,6,8),3], length=0.05, angle=90, code=3, lty=6)
axis(1, at=c(1,3,5,7)+0.5, labels=x.lab, tick=FALSE)
abline(h=true.values.sim2[1])
#for path 2:
x.lab=c("exp 0.2","exp 0.35", "exp 0.49", "exp 0.6")
plot(fig2.sim2[,5],  xaxt="n", ylim=c(-0.5, 0.2), ylab="", main="Path 2",xlab="")
points(c(2,4,6,8),fig2.sim2[c(2,4,6,8),5], pch=19)
arrows(c(1,3,5,7), fig2.sim2[c(1,3,5,7),6], c(1,3,5,7), fig2.sim2[c(1,3,5,7),7], length=0.05, angle=90, code=3, lty=1)
arrows(c(2,4,6,8), fig2.sim2[c(2,4,6,8),6], c(2,4,6,8), fig2.sim2[c(2,4,6,8),7], length=0.05, angle=90, code=3, lty=6)
axis(1, at=c(1,3,5,7)+0.5, labels=x.lab, tick=FALSE)
abline(h=true.values.sim2[2])
#for path 3:
x.lab=c("exp 0.2","exp 0.35", "exp 0.49", "exp 0.6")
plot(fig2.sim2[,9],  xaxt="n", ylim=c(-0.3, 0.5), ylab="", main="Path 3",xlab="")
points(c(2,4,6,8),fig2.sim2[c(2,4,6,8),9], pch=19)
arrows(c(1,3,5,7), fig2.sim2[c(1,3,5,7),10], c(1,3,5,7), fig2.sim2[c(1,3,5,7),11], length=0.05, angle=90, code=3, lty=1)
arrows(c(2,4,6,8), fig2.sim2[c(2,4,6,8),10], c(2,4,6,8), fig2.sim2[c(2,4,6,8),11], length=0.05, angle=90, code=3, lty=6)
axis(1, at=c(1,3,5,7)+0.5, labels=x.lab, tick=FALSE)
abline(h=true.values.sim2[3])

mtext("Scenario 1", side=2,line=1.5, outer=TRUE,las=0, adj=1)
mtext("Scenario 2", side=2,line=1.5, outer=TRUE,las=0, adj=0)
mtext("Effect value", side=2, line=0, outer=TRUE, las=0)
mtext("Exposure value", side=1, line=0, outer=TRUE)
par(fig=c(0,1,0,1),oma=c(0,0,0,0), mar=c(0,0,0,0), new=TRUE)
plot(0,0, type="n", bty="n", xaxt="n", yaxt="n")
legend("bottomright", c("delta", "bootstrap"), xpd=TRUE,horiz=TRUE,pch = c(1,19), lty = c(1,6), inset=c(0,0),bty="n")

#supplement appendix 6: plot RR under log scale----
dev.off()
png(filename="continuous_figure2RR.png")
par(mfrow=c(2,3), oma=c(2,3,0,0), mar=c(3,2,2,2))

#simulation 1
#for path 1:
x.lab=c("exp 0.2","exp 0.35", "exp 0.49", "exp 0.6")
plot(log(fig2.sim1[,13]),  xaxt="n", ylim=c(-0.5, 0.5), ylab="", main="Path 1",xlab="")
points(c(2,4,6,8),log(fig2.sim1[c(2,4,6,8),13]), pch=19)
arrows(c(1,3,5,7), log(fig2.sim1[c(1,3,5,7),14]), c(1,3,5,7), log(fig2.sim1[c(1,3,5,7),15]), length=0.05, angle=90, code=3, lty=1)
arrows(c(2,4,6,8), log(fig2.sim1[c(2,4,6,8),14]), c(2,4,6,8), log(fig2.sim1[c(2,4,6,8),15]), length=0.05, angle=90, code=3, lty=6)
axis(1, at=c(1,3,5,7)+0.5, labels=x.lab, tick=FALSE)
abline(h=log(true.values.sim1[4]))
#for path 2:
x.lab=c("exp 0.2","exp 0.35", "exp 0.49", "exp 0.6")
plot(log(fig2.sim1[,17]),  xaxt="n", ylim=c(-0.5, 0.5), ylab="", main="Path 2",xlab="")
points(c(2,4,6,8),log(fig2.sim1[c(2,4,6,8),17]), pch=19)
arrows(c(1,3,5,7), log(fig2.sim1[c(1,3,5,7),18]), c(1,3,5,7), log(fig2.sim1[c(1,3,5,7),19]), length=0.05, angle=90, code=3, lty=1)
arrows(c(2,4,6,8), log(fig2.sim1[c(2,4,6,8),18]), c(2,4,6,8), log(fig2.sim1[c(2,4,6,8),19]), length=0.05, angle=90, code=3, lty=6)
axis(1, at=c(1,3,5,7)+0.5, labels=x.lab, tick=FALSE)
abline(h=log(true.values.sim1[5]))
#for path 3:
x.lab=c("exp 0.2","exp 0.35", "exp 0.49", "exp 0.6")
plot(log(fig2.sim1[,21]),  xaxt="n", ylim=c(-0.5,0.5), ylab="", main="Path 3",xlab="")
points(c(2,4,6,8),log(fig2.sim1[c(2,4,6,8),21]), pch=19)
arrows(c(1,3,5,7), log(fig2.sim1[c(1,3,5,7),22]), c(1,3,5,7), log(fig2.sim1[c(1,3,5,7),23]), length=0.05, angle=90, code=3, lty=1)
arrows(c(2,4,6,8), log(fig2.sim1[c(2,4,6,8),22]), c(2,4,6,8), log(fig2.sim1[c(2,4,6,8),23]), length=0.05, angle=90, code=3, lty=6)
axis(1, at=c(1,3,5,7)+0.5, labels=x.lab, tick=FALSE)
abline(h=log(true.values.sim1[6]))
#simulation 2
#for path 1:
x.lab=c("exp 0.2","exp 0.35", "exp 0.49", "exp 0.6")
plot(log(fig2.sim2[,13]),  xaxt="n", ylim=c(-3,1), ylab="", main="Path 1",xlab="")
points(c(2,4,6,8),log(fig2.sim2[c(2,4,6,8),13]), pch=19)
arrows(c(1,3,5,7), log(fig2.sim2[c(1,3,5,7),14]), c(1,3,5,7), log(fig2.sim2[c(1,3,5,7),15]), length=0.05, angle=90, code=3, lty=1)
arrows(c(2,4,6,8), log(fig2.sim2[c(2,4,6,8),14]), c(2,4,6,8), log(fig2.sim2[c(2,4,6,8),15]), length=0.05, angle=90, code=3, lty=6)
axis(1, at=c(1,3,5,7)+0.5, labels=x.lab, tick=FALSE)
abline(h=log(true.values.sim2[4]))
#for path 2:
x.lab=c("exp 0.2","exp 0.35", "exp 0.49", "exp 0.6")
plot(log(fig2.sim2[,17]),  xaxt="n", ylim=c(-3,1), ylab="", main="Path 2",xlab="")
points(c(2,4,6,8),log(fig2.sim2[c(2,4,6,8),17]), pch=19)
arrows(c(1,3,5,7), log(fig2.sim2[c(1,3,5,7),18]), c(1,3,5,7), log(fig2.sim2[c(1,3,5,7),19]), length=0.05, angle=90, code=3, lty=1)
arrows(c(2,4,6,8), log(fig2.sim2[c(2,4,6,8),18]), c(2,4,6,8), log(fig2.sim2[c(2,4,6,8),19]), length=0.05, angle=90, code=3, lty=6)
axis(1, at=c(1,3,5,7)+0.5, labels=x.lab, tick=FALSE)
abline(h=log(true.values.sim2[5]))
#for path 3:
x.lab=c("exp 0.2","exp 0.35", "exp 0.49", "exp 0.6")
plot(log(fig2.sim2[,21]),  xaxt="n", ylim=c(-1,3), ylab="", main="Path 3",xlab="")
points(c(2,4,6,8),log(fig2.sim2[c(2,4,6,8),21]), pch=19)
arrows(c(1,3,5,7), log(fig2.sim2[c(1,3,5,7),22]), c(1,3,5,7), log(fig2.sim2[c(1,3,5,7),23]), length=0.05, angle=90, code=3, lty=1)
arrows(c(2,4,6,8), log(fig2.sim2[c(2,4,6,8),22]), c(2,4,6,8), log(fig2.sim2[c(2,4,6,8),23]), length=0.05, angle=90, code=3, lty=6)
axis(1, at=c(1,3,5,7)+0.5, labels=x.lab, tick=FALSE)
abline(h=log(true.values.sim2[6]))
mtext("Scenario 1", side=2,line=1.5, outer=TRUE,las=0, adj=1)
mtext("Scenario 2", side=2,line=1.5, outer=TRUE,las=0, adj=0)
mtext("Log Effect value", side=2, line=0, outer=TRUE, las=0)
mtext("Exposure value", side=1, line=0, outer=TRUE)
par(fig=c(0,1,0,1),oma=c(0,0,0,0), mar=c(0,0,0,0), new=TRUE)
plot(0,0, type="n", bty="n", xaxt="n", yaxt="n")
legend("bottomright", c("delta", "bootstrap"), xpd=TRUE,horiz=TRUE,pch = c(1,19), lty = c(1,6), inset=c(0,0),bty="n")
dev.off()
#check time----
sim.x=as.data.frame(sim.mediation.data(c(0.05,0.05), 0, 1000, exposure.values[i], 1,0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1))
system.time(mediation.analysis(1, sim.x, c()))
system.time(boot.mediation.analysis(1, sim.x, c(),n.boot=1000))


#supplementary table 7 and 8 effect of sigma M and sigma G changing----
#using simulation 1 exposure 0.2
change.sig=matrix(NA, nc=49,nr=0)
change.sig=rbind(change.sig,c(0.05,0.25,sim.mediation.calc( c(0.05,0.25), 0, 1000, 0.2 ,0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1)))
data.boot=boot.mediation.calc( c(0.05,0.25), 0, 1000, 0.2 ,0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1, 500)
change.sig=rbind(change.sig,c( 0.05,0.25,data.boot))

change.sig=rbind(change.sig,c(0.25,0.05,sim.mediation.calc( c(0.25,0.05), 0, 1000, 0.2 ,0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1)))
data.boot=boot.mediation.calc( c(0.25,0.05), 0, 1000, 0.2 ,0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1, 500)
change.sig=rbind(change.sig,c( 0.25,0.05,data.boot))

change.sig=rbind(change.sig,c(0.25,0.25,sim.mediation.calc( c(0.25,0.25), 0, 1000, 0.2 ,0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1)))
data.boot=boot.mediation.calc( c(0.25,0.25), 0, 1000, 0.2 ,0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1, 500)
change.sig=rbind(change.sig,c( 0.25,0.25,data.boot))

#sim 1 exposure 0.49
change.sig=rbind(change.sig,c(0.05,0.25,sim.mediation.calc( c(0.05,0.25), 0, 1000, 0.49 ,0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1)))
data.boot=boot.mediation.calc( c(0.05,0.25), 0, 1000, 0.49 ,0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1, 500)
change.sig=rbind(change.sig,c( 0.05,0.25,data.boot))

change.sig=rbind(change.sig,c(0.25,0.05,sim.mediation.calc( c(0.25,0.05), 0, 1000, 0.49 ,0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1)))
data.boot=boot.mediation.calc( c(0.25,0.05), 0, 1000, 0.49 ,0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1, 500)
change.sig=rbind(change.sig,c( 0.25,0.05,data.boot))

change.sig=rbind(change.sig,c(0.25,0.25,sim.mediation.calc( c(0.25,0.25), 0, 1000, 0.49 ,0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1)))
data.boot=boot.mediation.calc( c(0.25,0.25), 0, 1000, 0.49 ,0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1, 500)
change.sig=rbind(change.sig,c( 0.25,0.25,data.boot))

change.sig=as.data.frame(change.sig)
names(change.sig)=c("sigmaM", "sigmaG", names(data.boot))
write.csv(change.sig, file = "small_cont_figure4_changesigma_mar4.csv", row.names = T)
#to read the table: 
#every odd line is using the delta method, every even line using the bootstrap method
#95% CI coverage for risk difference is column 9:11 for path 1, 2, and 3 respectively
#95% CI coverage for risk ratio is column 12:14 for path 1,2, and 3 respectively
#columns 15,16,17,18 are for Y(0,0,0), Y(1,0,0), Y(1,1,0), Y(1,1,1) respectively these values are the same whether you use it for the boostrap method or delta
#columns 19 to 27 are 95% confidence intervals containing the true coefficient parameter for beta0, betaQ, betaW, betaH, alpha0, alphaQ, alphaW, delta0, and deltaQ respectively.
change.sig_prev02=change.sig[c(1:6),c(9:27)]
write.csv(change.sig_prev02, file="cont_figure7_changesigma_mar7.csv", row.names=T)
change.sig_prev49=change.sig[c(7:12), c(9:27)]
write.csv(change.sig_prev49, file="cont_figure8_changesigma_mar7.csv", row.names=T)
#supplementary table 9 data can be found from the following data ----
#delta values are same as the data from table 1 of the main text
supp5.data=matrix(NA, nc=49,nr=8)
supp5.data[1,]=c(0.05,0.05,sim.mediation.calc( c(0.05,0.05), 0, 1000, 0.2 ,0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1))
supp5.data[2,]=c(0.05,0.05, boot.mediation.calc( c(0.05,0.05), 0, 1000, 0.2 ,0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1, 500))
supp5.data[3,]=c(0.05,0.05,sim.mediation.calc( c(0.05,0.05), 0, 1000, 0.49 ,0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1))
supp5.data[4,]=c(0.05,0.05, boot.mediation.calc( c(0.05,0.05), 0, 1000, 0.49 ,0.1, 0.1, 0.4, -0.4, 0.1, 0.2, 0.2, 0, 0.1,c(), 1000, 1, 500))
supp5.data[5,]=c(0.05,0.05,sim.mediation.calc( c(0.05,0.05), 0, 1000, 0.2 ,-0.2, -0.3, -0.4, -0.4, 0, 0.2, 0.2, 0.2, 0.5,c(), 1000, 1))
supp5.data[6,]=c(0.05,0.05, boot.mediation.calc( c(0.05,0.05), 0, 1000, 0.2 ,-0.2, -0.3, -0.4, -0.4, 0, 0.2, 0.2, 0.2, 0.5,c(), 1000, 1,500))
supp5.data[7,]=c(0.05,0.05,sim.mediation.calc( c(0.05,0.05), 0, 1000, 0.49 ,-0.2, -0.3, -0.4, -0.4, 0, 0.2, 0.2, 0.2, 0.5,c(), 1000, 1))
supp5.data[8,]=c(0.05,0.05, boot.mediation.calc( c(0.05,0.05),0, 1000, 0.49 ,-0.2, -0.3, -0.4, -0.4, 0, 0.2, 0.2, 0.2, 0.5,c(), 1000, 1,500))

supp5.combine=rbind(c(rbind(supp5.data[1,c(9:14)],supp5.data[2,c(9:14)])), c(rbind(supp5.data[3,c(9:14)],supp5.data[4,c(9:14)])),c(rbind(supp5.data[5,c(9:14)],supp5.data[6,c(9:14)])),c(rbind(supp5.data[7,c(9:14)],supp5.data[8,c(9:14)]))) 
supp5.combine=as.data.frame(supp5.combine)
names(supp5.combine)=c("RDpath1Delta","RDpath1Boot",  "RDpath2Delta","RDpath2Boot",  "RDpath3Delta", "RDpath3Boot", "RRpath1Delta","RRpath1Boot", "RRpath2Delta", "RRpath2Boot","RRpath3Delta","RRpath3Boot")
write.csv(supp5.combine, file = "figure9_continuous_mar4.csv", row.names = T)
